
<script setup>
import * as yup from 'yup';
import { Form, Field } from 'vee-validate'
import { ref } from 'vue'
import api from '@/api/api'

const select = ref(null)
const items = ref([
    { state: 'کارتن', id: 0 },
    { state: 'گونی', id: 1 },
    { state: 'جامبو بگ', id: 2 },
    { state: 'پلت', id: 3 },
    { state: 'بندل ', id: 4 },
    { state: 'بشکه ', id: 5 },
    { state: 'قوطی ', id: 6 },
    { state: 'فله ', id: 7 },
    { state: 'IBC', id: 8 },
    { state: 'Flexi Tank', id: 9 },
    { state: 'سایر ', id: 10 }
])
const product = ref({
    first_name: '',
    last_name: '',
    description: '',
    phone: '',
    email: '',
    product_brand_name: '',
    origin: '',
    destination: '',
    weight: '',
    volume: '',
    package_type: '',
    package_count: '',
    container: '',
    shipping_method: '',
    proforma_file: null,
    packing_list_file: null,
    product_image: null
})
const handleFileChange = (event, item) => {
    var input = event.target;
    if (input.files) {

        var reader = new FileReader();
        reader.onload = (e) => {
            product.value[item] = e.target.result
        }
        product.value[item] = (input.files[0]);
        reader.readAsDataURL(input.files[0]);
    }
}
const validationRequired = ref('را وارد کنید')
const inquiryForm = yup.object({
    first_name: yup.string().required(`نام ${validationRequired.value}`),
    last_name: yup.string().required(`نام خانوادگی ${validationRequired.value}`),
    phone: yup.string().trim().matches(/^(\+98|0)?9\d{9}$/, 'لطفا شماره همراه را صحیح وارد کنید').required(`تلفن همراه ${validationRequired.value}`),
    product_brand_name: yup.string().required(`نام تجاری کالا ${validationRequired.value}`),
    origin: yup.string().required(`مبدا ${validationRequired.value}`),
    destination: yup.string().required(`مقصد ${validationRequired.value}`),
    weight: yup.number().transform((value) => (isNaN(value) ? undefined : value)).required(`وزن ${validationRequired.value}`),
    email: yup.string().email('لطفا پست الکترونیکی را صحیح وارد کنید'),
});
const loading = ref(false)
const snackbar = ref(false)
const snackbarClass = ref('')
const snackbarText = ref('')
const onSubmit = (values, { resetForm }) => {
    loading.value = true
    product.value.package_type = select.value.id
    api.post(`inquiry`, product.value).then(res => {
        loading.value = false
        snackbar.value = true
        snackbarClass.value = 'green-accent-2'
        snackbarText.value = 'درخواست شما با موفقیت ثبت شد'
        resetForm();
    }).catch(err => {
        loading.value = false
        snackbar.value = true
        snackbarClass.value = 'deep-orange-accent-2'
        snackbarText.value = 'متاسفانه مشکلی رخ داده است. لطفا دوباره سعی کنید.'
    })
}
</script>

<template>
    <v-snackbar v-model="snackbar" :color="snackbarClass" location="top" :timeout="5000">
        {{ snackbarText }}
        <template v-slot:actions>
            <v-btn color="white" variant="text" @click="snackbar = false">
                <BootstrapIcon name="x-circle"></BootstrapIcon>
            </v-btn>
        </template>
    </v-snackbar>
    <Form as="v-form" :validation-schema="inquiryForm" @submit="onSubmit">
        <v-card-title>مشخصات فردی </v-card-title>
        <v-row class="ma-auto">
            <v-col cols="lg-3" md="4" sm="6">
                <Field name="first_name" v-model="product.first_name" v-slot="{ field, errors }">
                    <v-text-field density="compact" v-bind="field" v-model.trim="product.first_name" label="نام"
                        variant="outlined" :error-messages="errors"></v-text-field>
                </Field>
            </v-col>
            <v-col cols="lg-3" md="4" sm="6">
                <Field name="last_name" v-model="product.last_name" v-slot="{ field, errors }">
                    <v-text-field density="compact" v-bind="field" v-model.trim="product.last_name" label="نام خانوادگی"
                        variant="outlined" :error-messages="errors"></v-text-field>
                </Field>
            </v-col>
            <v-col cols="lg-3" md="4" sm="6">
                <Field name="phone" v-model="product.phone" v-slot="{ field, errors }">
                    <v-text-field density="compact" v-bind="field" v-model.trim="product.phone" label="تلفن همراه"
                        variant="outlined" :error-messages="errors"></v-text-field>
                </Field>
            </v-col>
            <v-col cols="lg-3" md="4" sm="6">
                <Field name="email" v-model="product.email" v-slot="{ field, errors }">
                    <v-text-field density="compact" v-bind="field" v-model.trim="product.email" label="پست الکترونیکی"
                        variant="outlined" :error-messages="errors"></v-text-field>
                </Field>
            </v-col>
        </v-row>
        <v-card-title>مشخصات کالا </v-card-title>
        <v-row class="ma-auto">
            <v-col cols="lg-3" md="4" sm="6">
                <Field name="product_brand_name" v-model="product.product_brand_name" v-slot="{ field, errors }">
                    <v-text-field density="compact" v-bind="field" v-model.trim="product.product_brand_name"
                        label="نام تجاری کالا" variant="outlined" :error-messages="errors"></v-text-field>
                </Field>
            </v-col>
            <v-col cols="lg-3" md="4" sm="6">
                <Field name="origin" v-model="product.origin" v-slot="{ field, errors }">
                    <v-text-field density="compact" v-bind="field" v-model.trim="product.origin" label="مبدا"
                        variant="outlined" :error-messages="errors"></v-text-field>
                </Field>
            </v-col>
            <v-col cols="lg-3" md="4" sm="6">
                <Field name="destination" v-model="product.destination" v-slot="{ field, errors }">
                    <v-text-field density="compact" v-bind="field" v-model.trim="product.destination" label="مقصد"
                        variant="outlined" :error-messages="errors"></v-text-field>
                </Field>
            </v-col>
            <v-col cols="lg-3" md="4" sm="6">
                <Field name="weight" v-model="product.weight" v-slot="{ field, errors }">
                    <v-text-field density="compact" v-bind="field" type="number" dir="ltr" min="0"
                        v-model.trim="product.weight" label="وزن" variant="outlined"
                        :error-messages="errors"></v-text-field>
                </Field>
            </v-col>
            <v-col cols="lg-3" md="4" sm="6">
                <v-text-field density="compact" type="number" dir="ltr" min="0" v-model.trim="product.volume" label="ابعاد"
                    variant="outlined"></v-text-field>
            </v-col>
            <v-col cols="lg-3" md="4" sm="6">
                <v-select variant="outlined" density="compact" v-model="select" :items="items" item-title="state"
                    item-value="id" label="نوع بسته بندی" return-object single-line>
                </v-select>
            </v-col>
            <v-col cols="lg-3" md="4" sm="6">
                <v-text-field density="compact" type="number" dir="ltr" min="0" v-model.trim="product.package_count"
                    label="تعداد بسته بندی" variant="outlined"></v-text-field>
            </v-col>
            <v-col cols="lg-3" md="4" sm="6">
                <v-text-field density="compact" v-model.trim="product.container" label="ظرف حمل"
                    variant="outlined"></v-text-field>
            </v-col>
            <v-col cols="lg-3" md="4" sm="6">
                <v-text-field density="compact" v-model.trim="product.shipping_method" label="روش حمل"
                    variant="outlined"></v-text-field>
            </v-col>
            <v-col cols="lg-3" md="4" sm="6">
                <v-file-input clear-icon="bi-x-circle" @change="handleFileChange($event, 'proforma_file')" chips
                    density="compact" prepend-inner-icon="bi-cloud-arrow-up" v-model="product.proforma_file"
                    label="آپلود پروفرما " variant="outlined"></v-file-input>
            </v-col>
            <v-col cols="lg-3" md="4" sm="6">
                <v-file-input clear-icon="bi-x-circle" @change="handleFileChange($event, 'packing_list_file')" chips
                    density="compact" prepend-inner-icon="bi-cloud-arrow-up" v-model="product.packing_list_file"
                    label="آپلود پکینگ لیست" variant="outlined"></v-file-input>
            </v-col>
            <v-col cols="lg-3" md="4" sm="6">
                <v-file-input clear-icon="bi-x-circle" @change="handleFileChange($event, 'product_image')" chips
                    density="compact" prepend-inner-icon="bi-cloud-arrow-up" v-model="product.product_image"
                    label="آپلود تصویر نمونه کالا " variant="outlined"></v-file-input>
            </v-col>
            <v-col cols="12">
                <v-textarea v-model="product.description" label="توضیحات" auto-grow variant="outlined" rows="5"
                    row-height="15"></v-textarea>
            </v-col>
            <v-btn :loading="loading" :disabled="loading" @submit="onSubmit" type="submit" class="mx-3 text-white"
                size="large" color="#1A237E">
                استعلام قیمت
            </v-btn>
        </v-row>
    </Form>
</template>


<style lang="scss" scoped>
.v-form {
    .v-col-lg-3 {
        padding-bottom: 0;
    }
}
</style>